//Chirag Kakad  5548112
//FA simulator
import java.io.File;
import java.util.ArrayList;
import java.util.Scanner;


public class FA {
	private static String[][] fa;
	private static final File config = new File("src/config.fa");
	private static int start;
	private static ArrayList<Integer> except = new ArrayList<Integer>();
	private static int numChar;
	private static int numTran;

	private static void loadConfig(){
		try {
			Scanner input = new Scanner(config);
			int i = 0;
			int l = 1;
			String line = "";
			while (input.hasNext()){
				line = input.nextLine();
				String[] buffer = line.split(",");
				if (i == 0){
					numChar = Integer.parseInt(buffer[0]);
					numTran = Integer.parseInt(buffer[1]);
					fa = new String[numTran+1][numChar+1];
					fa[0][0] = "Q";
				}
				else
					if (i == 1){
						int k = 1;
						for (int j = 0; j<buffer.length; j++){
							fa[0][k] = buffer[j];
							k++;
						}
					}
					else{
						if (buffer[0].contains(">"))
							start = l;
						if (buffer[0].contains("*"))
							except.add(l);
						for (int k = 0; k<fa[l].length; k++){
							fa[l][k] = buffer[k];
						}
						l++;
					}
				i++;
			}
			input.close();
		} catch (Exception e) {}
	}

	private static void print(){
		for (int i = 0; i<fa.length; i++){
			for (int j = 0; j<fa[i].length; j++)
				System.out.print(fa[i][j] + " ");
			System.out.println();
		}
	}
	private static int getCol(String str){
		for (int i = 1; i<fa[0].length; i++){
			if (fa[0][i].contains(str))
				return i;
		}
		return -1;
	}
	private static int getRow(String str){
		for (int i = 1; i<fa.length; i++){
			if (fa[i][0].contains(str))
				return i;
		}
		return -1;
	}
	public static void main(String[] args) {
		loadConfig();
		print();
		Scanner input = new Scanner(System.in);
		String str = "";
		while (!str.equalsIgnoreCase("exit")){
			System.out.print("Enter a string in the system to test or \'exit\' to terminate: ");
			str = input.nextLine();
			boolean ex = true;
			int st = start;
			str = str.trim();
			if (str.equalsIgnoreCase("exit"))
				break;
			String configuration = "[";
			for (int i = 0; i<str.length(); i++){
				String c = Character.toString(str.charAt(i));
				if (getCol(c) == -1){
					System.out.println("Error: invalid string: \'" + str + "\'.");
					ex = false;
					break;
				}
				configuration += "{" + fa[st][0] + ", " + str.substring(i, str.length()) + "}, ";
				st = getRow(fa[st][getCol(c)]);
			}
			if (ex && !str.isEmpty()){
				configuration += "{" + fa[st][0] + "}]";
				System.out.println(configuration);
				for (int i = 0; i<except.size(); i++){
					if (st == except.get(i)){
						System.out.println("the string \'" + str + "\' is excepted by the machine.");
						break;
					}
					if (i == except.size() -1)
						System.out.println("The string \'" + str + "\' is not excepted by the machine.");
				}
			}
		}
		System.out.println("Thank You for using the finite automata simulator!");
		input.close();
	}

}
